<script setup lang="ts">
import {ref, watch} from "vue";

interface IProps {
  counter: number,
  name: string,
  confirmedName: string,
  fullName: string,
}

const props = withDefaults(defineProps<IProps>(), {
  counter: 10,
  name: '',
  confirmedName: '',
  fullName: '',
})

const counter = ref(props.counter);
let name = ref(props.name);
const confirmedName = ref(props.confirmedName);
let fullName = ref(props.fullName);

const increment = (value: number) => {
  counter.value = counter.value + value;
}

const decrement = (value: number) => {
  counter.value = counter.value - value;
}


const submitForm = (event: Event) => {
  alert("Submitted");
}

const resetInput = () => {
  name.value = '';
}

const outputFullName = () => {
  console.log('Running again....');
  if(name.value === ''){
    return '';
  }
  return name.value + ' ' + 'Dang';
}

watch(name, async (newName, oldName) => {
  fullName.value = newName + ' ' + 'Dang';
})

</script>

<template>
  <header>
    <h1>Vue Events</h1>
  </header>
  <section id="events">
    <h2>Events in Action</h2>
    <button v-on:click="increment(10)">Add 10</button>
    <button v-on:click.right="decrement(5)">Subtract 5</button>
    <p v-once>Starting Counter: {{ counter }}</p>
    <p>Result: {{ counter }}</p>
    <input type="text" v-model="name">
    <button v-on:click="resetInput">Reset Input</button>
    <p>Your name: {{ fullName }}</p>
    <form v-on:submit.prevent="submitForm">
      <input type="text">
      <button>Sign Up</button>
    </form>
  </section>
</template>